// Type definitions for react-auth-kit 1.2
// Project: https://github.com/react-auth-kit/react-auth-kit#readme
// Definitions by: Arkadip Bhattacharya <https://github.com/darkmatter18>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

import AuthProvider from './AuthProvider';
import PrivateRoute from './PrivateRoute';
import useAuth from './hooks/useAuth';
import useSignIn from './hooks/useSignIn';
import useSignOut from './hooks/useSignOut';
import useAuthUser from './hooks/useAuthUser';
import useAuthHeader from './hooks/useAuthHeader';
import useIsAuthenticated from './hooks/useIsAuthenticated';
import withSignIn from './higherOrderComponents/withSignIn';
import withSignOut from './higherOrderComponents/withSignOut';
import withAuthUser from './higherOrderComponents/withAuthUser';
import withAuthHeader from './higherOrderComponents/withAuthHeader';
import withIsAuthenticated from './higherOrderComponents/withIsAuthenticated';
export { AuthProvider, PrivateRoute, useAuth, useSignIn, useSignOut, useAuthUser, useAuthHeader, useIsAuthenticated, withSignIn, withSignOut, withAuthUser, withAuthHeader, withIsAuthenticated };
