import * as React from 'react';

import AsyncSelect from 'react-select/async';
import { colourOptions } from '../data';
import { OptionsType } from 'react-select/src/types';

interface State {
    inputValue: string;
}

const filterColors = (inputValue: string) =>
    colourOptions.filter(i => i.label.toLowerCase().includes(inputValue.toLowerCase()));

const loadOptions = (inputValue: string, callback: (c: OptionsType<any>) => void) => {
    setTimeout(() => {
        callback(filterColors(inputValue));
    }, 1000);
};

export default class WithCallbacks extends React.Component<any, State> {
    state = { inputValue: '' };
    handleInputChange = (newValue: string) => {
        const inputValue = newValue.replace(/\W/g, '');
        this.setState({ inputValue });
        return inputValue;
    }
    render() {
        return (
            <div>
                <pre>inputValue: "{this.state.inputValue}"</pre>
                <AsyncSelect
                    cacheOptions
                    loadOptions={loadOptions}
                    defaultOptions
                    onInputChange={this.handleInputChange}
                />
            </div>
        );
    }
}
